#!/usr/bin/perl

# Comment this next line out (put a # in front of it) if you don't 
# have CGI.pm installed on your server.  Most servers have it, 
# so don't worry. 

use CGI::Carp qw(fatalsToBrowser);

##############################################################################
# COPYRIGHT NOTICE                                                           #
# TigerTom's Robot Rat Script. Version: 1.0, April 2002.                     # 
#                                                                            #  
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                   #
# http://www.tigertom.com/contact.htm                                        #
#                                                                            #
# This Perl script may be used and modified by any purchaser so              # 
# long as this copyright notice and the comments below remain intact.        #                                               #
#                                                                            # 
# It may only be used on domains owned by the purchaser.                     #
#                                                                            #
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'     #
# Donnell from any liability that might arise from its use.                  #                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.                                                       #
# You must get permission from T. O' Donnell before redistributing this      #
# software over the Internet or via any other medium.                        #                                      #
# You may not redistribute an altered version of this program in any form,   # 
# via any medium.                                                            # 
#                                                                            #
# In all cases copyright and header must remain intact.                      #
#                                                                            #                    
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United Kingdom Of Great Britain.                 #
#                                                                            #
##############################################################################

# Robot Rat Script - informs on accesses by bots and leech programs.
# By T. O' Donnell.  Copyright T. O' Donnell, 2002.

# Password sent to this script as a query_string when you want
# to print out the information its saved e.g.
# http://www.tigertom.com/cgi-bin/robot_rat/robot_rat.cgi?pa55w0rd

$password = "G00DScr1Pt";

# File to record attempts to.
# This says it's in the same directory as the script:
$access_attempt_file = "access.dat";

# File Locking.
# Does your system have file locking ('flock')?  This stops your data 
# files getting corrupted when different users try to save to the 
# same file simultaneously.  If it does, change the following value to
# 1, e.g. $lockit = 1;. If you're on a Windows server, set it to 0.

$lockit = 0;


########## END OF USER-DEFINED VARIABLES SECTION ####################

$their_pass = $ENV{'QUERY_STRING'};
$their_pass =~ s/<//g;
$their_pass =~ s/>//g;

if($their_pass eq "$password") {
open (RECORD, "<$access_attempt_file") || die "Error - cannot open $access_attempt_file: $!";
         if($lockit){flock(RECORD,2);}
         @access = <RECORD>;
	if($lockit){flock(RECORD,8);}
         close (RECORD);

print "Content-type: text/html\n\n";
print "<FONT FACE=\"Arial\"><HEAD><TITLE>Robot Rat Squeals</TITLE></HEAD>\n";
print "<BODY><H3>The Robot Rat script has sniffed out the following visitors:</H3>\n";
      foreach $line(@access) {
        chomp($line);
        print "<FONT SIZE =\"1\">$line</FONT><BR>\n";
           } # End foreach
        print "</FONT></BODY></HTML><BR>\n"; 
	exit(0);

     } # End if

# Get the date
&get_date;


# Now record the leech
&save_id;

exit(0);


#### Get the date #### 
sub get_date {

# Get the date :

($Sec,$Min,$Hour,$Mday,$Mon,$Year,$Wday) = (localtime(time))[0,1,2,3,4,5,6];
        $Mon++;
        if ($Sec < 10) { $Sec = "0$Sec"; }
        if ($Min < 10) { $Min = "0$Min"; }
        if ($Hour < 10) { $Hour = "0$Hour"; }
        if ($Mday < 10) { $Mday = "0$Mday"; }
        if ($Year < 70){$Year = ($Year + 2000);}
            else {$Year = ($Year + 1900);}
        $Date = "$Mon/$Mday/$Year";
        $Time = "$Hour:$Min:$Sec";

  }


sub save_id {

 open (RECORD, ">>$access_attempt_file") || die "Error - cannot open $access_attempt_file: $!";
         if($lockit){flock(RECORD,2);}
   # Print this querent's info
         print RECORD "$Date|$ENV{'REMOTE_ADDR'}|$ENV{'HTTP_USER_AGENT'}|$ENV{'REMOTE_HOST'}|$ENV{'HTTP_FORWARDED'}\n";
        if($lockit){flock(RECORD,8);}
         close (RECORD);

   } # End save id  


